VSTGUI: CView Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Groups Pages
Classes | Public Types | Public Member Functions | Protected Types | Protected Member Functions | List of all members
CView Class Reference
Views

Base Class of all view objects. More...

Inheritance diagram for CView:

## Classes
struct | Impl

## Public Types
enum | MouseListenerCall { MouseDown, MouseMoved, MouseUp, MouseCancel }

## Public Member Functions
| CView (const CRect &size)
| CView (const CView &view)
void | setSubviewState (bool state)
bool | isSubview () const
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
virtual CViewContainer * | asViewContainer ()
virtual const CViewContainer * | asViewContainer () const
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
void | beforeDelete () override
CBaseObject * | newCopy () const override
Event Handling Methods
virtual void | dispatchEvent (Event &event)
| dispatch an event
Mouse Methods
virtual void | onMouseDownEvent (MouseDownEvent &event)
| called when a mouse down event occurs
virtual void | onMouseMoveEvent (MouseMoveEvent &event)
| called when a mouse move event occurs
virtual void | onMouseUpEvent (MouseUpEvent &event)
| called when a mouse up event occurs
virtual void | onMouseCancelEvent (MouseCancelEvent &event)
| called when mouse tracking should be canceled
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | onMouseWheelEvent (MouseWheelEvent &event)
| called when a mouse wheel event occurs
virtual void | onZoomGestureEvent (ZoomGestureEvent &event)
| called when a zoom gesture event occurs
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
virtual bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons)
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
Hit testing Methods
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
Drag & Drop Methods
## /
    /** start a drag operation
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| A drag can only be started from within onMouseDown or onMouseMove.
virtual SharedPointer < IDropTarget > | getDropTarget ()
| get the drag target for drag and drop handling
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
Keyboard Methods
virtual void | onKeyboardEvent (KeyboardEvent &event)
| called when a keyboard event is dispatched to this view
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
View Size Methods
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
virtual void | setViewSize (const CRect &rect, bool invalid=true)
| set views size
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
virtual void | parentSizeChanged ()
| notification that one of the views parent has changed its size
virtual CPoint & | frameToLocal (CPoint &point) const
| conversion from frame coordinates to local view coordinates
virtual CPoint & | localToFrame (CPoint &point) const
| conversion from local view coordinates to frame coordinates
virtual void | setAutosizeFlags (int32_t flags)
| set autosize flags
int32_t | getAutosizeFlags () const
| get autosize flags
virtual bool | sizeToFit ()
| resize view to optimal size
Focus Methods
virtual void | looseFocus ()
| called if view should loose focus
virtual void | takeFocus ()
| called if view should take focus
virtual bool | wantsFocus () const
| check if view supports focus
virtual void | setWantsFocus (bool state)
| set focus support on/off
Attribute Methods
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T >
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T >
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
Background Methods
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
Transparency Methods
virtual void | setTransparency (bool val)
| set views transparent state
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
Attaching Methods
virtual bool | removed (CView *parent)
| view is removed from parent view
virtual bool | attached (CView *parent)
| view is attached to a parent view
bool | isAttached () const
| is view attached to a parentView
Parent Methods
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
Animation Methods
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
View Listener Methods
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
Coordinate translation Methods
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T >
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T >
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T >
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexceptoverride=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
virtual CMessageResult | notify ([[maybe_unused]] CBaseObject *sender,[[maybe_unused]] IdStringPtr message)
Public Member Functions inherited from ReferenceCounted< T >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount

## Protected Types
enum | { kMouseEnabled = 1 << 0, kTransparencyEnabled = 1 << 1, kWantsFocus = 1 << 2, kIsAttached = 1 << 3, kVisible = 1 << 4, kDirty = 1 << 5, kWantsIdle = 1 << 6, kIsSubview = 1 << 7, kHasAlpha = 1 << 8, kHasBackground = 1 << 9, kHasDisabledBackground = 1 << 10, kHasMouseableArea = 1 << 11, kLastCViewFlag = 11 }

## Protected Member Functions
| ~CView () noexceptoverride
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)

## Draw and Update Methods
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle.
virtual void | draw (CDrawContext *pContext)
| called if the view should draw itself
virtual void | drawRect (CDrawContext *pContext, const CRect &updateRect)
| called if the view should draw itself
virtual bool | checkUpdate (const CRect &updateRect) const
virtual bool | isDirty () const
| check if view is dirty
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle.
virtual void | invalidRect (const CRect &rect)
| mark rect as invalid
virtual void | invalid ()
| mark whole view as invalid
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state

## Idle Methods
Should be used when a view needs to do a task periodically. The onIdle() method will be called only if the view is attached.
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not

## Detailed Description

Base Class of all view objects.

## Member Enumeration Documentation

anonymous enum
| protected

Enumerator
kMouseEnabled |
kTransparencyEnabled |
kWantsFocus |
kIsAttached |
kVisible |
kDirty |
kWantsIdle |
kIsSubview |
kHasAlpha |
kHasBackground |
kHasDisabledBackground |
kHasMouseableArea |
kLastCViewFlag |

enum MouseListenerCall

Enumerator
MouseDown |
MouseMoved |
MouseUp |
MouseCancel |

## Constructor & Destructor Documentation

CView | ( | const CRect & | size | ) |
| explicit

CView | ( | const CView & | view | ) |

~CView | ( |  | ) |
| overrideprotecteddefaultnoexcept

## Member Function Documentation

void addAnimation | ( | IdStringPtr | name,
|  | Animation::IAnimationTarget * | target,
|  | Animation::ITimingFunction * | timingFunction,
|  | CBaseObject * | notificationObject
| ) |  |

void addAnimation | ( | IdStringPtr | name,
|  | Animation::IAnimationTarget * | target,
|  | Animation::ITimingFunction * | timingFunction,
|  | const Animation::DoneFunction & | doneFunc = `nullptr`,
|  | bool | callDoneOnCancel = `false`
| ) |  |

virtual CViewContainer* asViewContainer | ( |  | ) |
| inlinevirtual

Reimplemented in CViewContainer.

virtual const CViewContainer* asViewContainer | ( |  | ) | const
| inlinevirtual

Reimplemented in CViewContainer.

bool attached | ( | CView * | parent | ) |
| virtual

view is attached to a parent view

Parameters

  parent | parent view

Returns
  true if view successfully attached to parent

Reimplemented in CFrame, CViewContainer, CSegmentButton, CDataBrowser, CSplitView, CFontChooser, UIViewSwitchContainer, CListControl, COpenGLView, CShadowViewContainer, CLayeredViewContainer, and CAutoLayoutContainerView.

void beforeDelete | ( |  | ) |
| overridevirtual

Reimplemented from ReferenceCounted< T >.

Reimplemented in CViewContainer.

CMouseEventResult callMouseListener | ( | MouseListenerCall | type,
|  | CPoint | pos,
|  | CButtonState | buttons
| ) |  |

void callMouseListenerEnteredExited | ( | bool | mouseEntered | ) |

virtual bool checkUpdate | ( | const CRect & | updateRect | ) | const
| inlinevirtual

void dispatchEvent | ( | Event & | event | ) |
| virtual

dispatch an event

the event is then dispatched to the event listeners and then to one of the event methods.

Reimplemented in CFrame.

bool doDrag | ( | const DragDescription & | dragDescription,
|  | const SharedPointer< IDragCallback > & | callback = `{}`
| ) |  |

A drag can only be started from within onMouseDown or onMouseMove.

This method may return immediately before the drop occurs, if you want to be notified about the result you have to provide a callback object.

Parameters

  dragDescription | drag description
  callback | callback

Returns
  true if the drag was started, otherwise false

DragResult doDrag | ( | IDataPackage * | source,
|  | const CPoint & | offset = `CPoint (0, 0)`,
|  | CBitmap * | dragBitmap = `nullptr`
| ) |  |

a drag can only be started from within onMouseDown

Deprecated:
  start a drag operation. See CDropSource to create the source data package

Parameters

  source | source drop
  offset | bitmap offset
  dragBitmap | bitmap to drag

Returns
  see DragResult

void draw | ( | CDrawContext * | pContext | ) |
| virtual

called if the view should draw itself

Parameters

  pContext | draw context in which to draw

Reimplemented in COptionMenu, CTextButton, CFrame, CAnimKnob, CSlider, CKickButton, CRockerSwitch, CViewContainer, CSegmentButton, CKnob, CParamDisplay, CCheckBox, CControl, CAnimationSplashScreen, CTextEdit, CGradientView, CTextLabel, CVuMeter, CScrollbar, CListControl, COnOffButton, CSwitchBase, CSearchTextEdit, CSplashScreen, CXYPad, CAutoAnimation, CMovieBitmap, CMovieButton, CSpecialDigit, and CControlCreatorDummyControl.

virtual void drawRect | ( | CDrawContext * | pContext,
|  | const CRect & | updateRect
| ) |  |
| inlinevirtual

called if the view should draw itself

Reimplemented in CFrame, CViewContainer, CSegmentButton, CMultiLineTextLabel, CListControl, CShadowViewContainer, and CLayeredViewContainer.

CPoint & frameToLocal | ( | CPoint & | point | ) | const
| virtual

conversion from frame coordinates to local view coordinates

Parameters

  point | location

Returns
  converted point

Reimplemented in CFrame, and CViewContainer.

float getAlphaValue | ( |  | ) | const

get alpha value

bool getAttribute | ( | const CViewAttributeID | aId,
|  | const uint32_t | inSize,
|  | void * | outData,
|  | uint32_t & | outSize
| ) |  | const

get an attribute

Parameters

  aId | the ID of the Attribute
  inSize | the size of the outData pointer
  outData | a pointer where to copy the attribute data
  outSize | the size in bytes which was copied into outData

Returns
  true if attribute exists and outData was big enough. outSize and outData is valid then.

bool getAttribute | ( | const CViewAttributeID | id,
|  | T & | data
| ) |  | const
| inline

get an attribute

bool getAttributeSize | ( | const CViewAttributeID | aId,
|  | uint32_t & | outSize
| ) |  | const

get the size of an attribute

Parameters

  aId | the ID of the Attribute
  outSize | on return the size of the attribute

Returns
  true if attribute exists. outSize is valid then.

int32_t getAutosizeFlags | ( |  | ) | const

get autosize flags

CBitmap * getBackground | ( |  | ) | const

get the background image of this view

CBitmap * getDisabledBackground | ( |  | ) | const

get background image used when the mouse is not enabled

CBitmap * getDrawBackground | ( |  | ) | const

get the bitmap which is drawn depending on the enabled state.

SharedPointer< IDropTarget > getDropTarget | ( |  | ) |
| virtual

get the drag target for drag and drop handling

Reimplemented in CViewContainer.

VSTGUIEditorInterface * getEditor | ( |  | ) | const
| virtual

get editor

Reimplemented in CFrame.

CFrame * getFrame | ( |  | ) | const

get frame

CGraphicsTransform getGlobalTransform | ( | bool | ignoreFrame = `false` | ) | const

get the active global transform for this view

CCoord getHeight | ( |  | ) | const
| inline

get the height of the view

CGraphicsPath * getHitTestPath | ( |  | ) | const
| protected

CRect getMouseableArea | ( |  | ) | const

get the area in which the view reacts to the mouse

CRect & getMouseableArea | ( | CRect & | rect | ) | const

get the area in which the view reacts to the mouse

bool getMouseEnabled | ( |  | ) | const
| inline

get the state of wheather this view uses the mouse or not

CView * getParentView | ( |  | ) | const

get parent view

bool getTransparency | ( |  | ) | const
| inline

get views transparent state

const CRect & getViewSize | ( |  | ) | const

read only access to view size

CRect getVisibleViewSize | ( |  | ) | const
| virtual

returns the visible size of the view

Returns
  visible size of view

CCoord getWidth | ( |  | ) | const
| inline

get the width of the view

bool hasViewFlag | ( | int32_t | bit | ) | const
| protected

bool hitTest | ( | const CPoint & | where,
|  | const Event & | event = `noEvent ()`
| ) |  |
| virtual

check if where hits this view

the default behaviour is to return true if where is inside the view size of this view, but if you set a hit test path the path is checked if the point lies in its boundaries.

Parameters

  where | location
  buttons | button and modifier state

Returns
  true if point hits this view

Reimplemented in CSplashScreen.

virtual void invalid | ( |  | ) |
| inlinevirtual

mark whole view as invalid

Reimplemented in CFrame, CViewContainer, and CLayeredViewContainer.

void invalidRect | ( | const CRect & | rect | ) |
| virtual

mark rect as invalid

Parameters

  rect | rect to invalidate

Reimplemented in CFrame, CViewContainer, COpenGLView, and CLayeredViewContainer.

bool isAttached | ( |  | ) | const
| inline

is view attached to a parentView

virtual bool isDirty | ( |  | ) | const
| inlinevirtual

check if view is dirty

Reimplemented in CViewContainer, and CControl.

bool isSubview | ( |  | ) | const
| inline

bool isVisible | ( |  | ) | const
| inline

get visibility state

CPoint & localToFrame | ( | CPoint & | point | ) | const
| virtual

conversion from local view coordinates to frame coordinates

Parameters

  point | location

Returns
  converted point

Reimplemented in CFrame, and CViewContainer.

void looseFocus | ( |  | ) |
| virtual

called if view should loose focus

Reimplemented in COptionMenu, CViewContainer, and CTextEdit.

CBaseObject* newCopy | ( |  | ) | const
| inlineoverride

CMessageResult notify | ( | CBaseObject * | sender,
|  | IdStringPtr | message
| ) |  |
| override

Parameters

  sender | message sender
  message | message text

Returns
  message handled or not. See CMessageResult

virtual void onIdle | ( |  | ) |
| inlinevirtual

called on idle when view wants idle

Reimplemented in CVuMeter.

void onKeyboardEvent | ( | KeyboardEvent & | event | ) |
| virtual

called when a keyboard event is dispatched to this view

This happens normally only if the view is the focus view.

Reimplemented in COptionMenu, CTextButton, CKickButton, CRockerSwitch, CSegmentButton, CDataBrowser, CCheckBox, CHorizontalSwitch, CVerticalSwitch, CTextEdit, CFontChooser, CSliderBase, CListControl, COnOffButton, CKnobBase, CXYPad, and CMovieButton.

int32_t onKeyDown | ( | VstKeyCode & | keyCode | ) |
| virtual

called if a key down event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

int32_t onKeyUp | ( | VstKeyCode & | keyCode | ) |
| virtual

called if a key up event occurs and this view has focus

Parameters

  keyCode | key code of pressed key

Returns
  -1 if not handled and 1 if handled

CMouseEventResult onMouseCancel | ( |  | ) |
| virtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Reimplemented in CTextButton, CKickButton, CRockerSwitch, CCheckBox, CSliderBase, CScrollbar, CKnobBase, COnOffButton, CSwitchBase, and CMovieButton.

void onMouseCancelEvent | ( | MouseCancelEvent & | event | ) |
| virtual

called when mouse tracking should be canceled

Reimplemented in CViewContainer, and CXYPad.

CMouseEventResult onMouseDown | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Parameters

  where | mouse location of mouse down
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in COptionMenu, CTextButton, CKickButton, CRockerSwitch, CSegmentButton, CDataBrowser, CCheckBox, CAnimationSplashScreen, CTextEdit, CSliderBase, CScrollbar, CListControl, CKnobBase, CSplashScreen, COnOffButton, CSwitchBase, CSearchTextEdit, CMovieButton, and CAutoAnimation.

void onMouseDownEvent | ( | MouseDownEvent & | event | ) |
| virtual

called when a mouse down event occurs

Reimplemented in CViewContainer, and CXYPad.

virtual CMouseEventResult onMouseEntered | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| inlinevirtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Reimplemented in CScrollbar.

void onMouseEnterEvent | ( | MouseEnterEvent & | event | ) |
| virtual

called when the mouse enters this view

virtual CMouseEventResult onMouseExited | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| inlinevirtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Reimplemented in CScrollbar, and CListControl.

void onMouseExitEvent | ( | MouseExitEvent & | event | ) |
| virtual

called when the mouse leaves this view

CMouseEventResult onMouseMoved | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Parameters

  where | mouse location of mouse move
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in CTextButton, CKickButton, CRockerSwitch, CCheckBox, CSliderBase, CScrollbar, CListControl, CKnobBase, COnOffButton, CSwitchBase, and CMovieButton.

void onMouseMoveEvent | ( | MouseMoveEvent & | event | ) |
| virtual

called when a mouse move event occurs

Reimplemented in CViewContainer, and CXYPad.

CMouseEventResult onMouseUp | ( | CPoint & | where,
|  | const CButtonState & | buttons
| ) |  |
| virtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Parameters

  where | mouse location of mouse up
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented in CTextButton, CKickButton, CRockerSwitch, CCheckBox, CSliderBase, CScrollbar, CListControl, CKnobBase, COnOffButton, CSwitchBase, and CMovieButton.

void onMouseUpEvent | ( | MouseUpEvent & | event | ) |
| virtual

called when a mouse up event occurs

Reimplemented in CViewContainer, and CXYPad.

void onMouseWheelEvent | ( | MouseWheelEvent & | event | ) |
| virtual

called when a mouse wheel event occurs

Reimplemented in CViewContainer, CRockerSwitch, CScrollView, CSliderBase, CScrollbar, CKnobBase, and CXYPad.

virtual bool onWheel | ( | const CPoint & | where,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| inlinefinalvirtual

Deprecated:
  never called anymore please use onMouseWheelEvent instead

bool onWheel | ( | const CPoint & | where,
|  | const CMouseWheelAxis & | axis,
|  | const float & | distance,
|  | const CButtonState & | buttons
| ) |  |
| virtual

Deprecated:
  please use onMouseWheelEvent instead

Parameters

  where | location
  axis | mouse wheel axis
  distance | wheel distance
  buttons | button and modifier state

Returns
  true if handled

Reimplemented in CViewContainer, and CTextLabel.

virtual void onWindowActivate | ( | bool | state | ) |
| inlinevirtual

called when the active state of the window changes

void onZoomGestureEvent | ( | ZoomGestureEvent & | event | ) |
| virtual

called when a zoom gesture event occurs

Reimplemented in CViewContainer.

virtual void parentSizeChanged | ( |  | ) |
| inlinevirtual

notification that one of the views parent has changed its size

Reimplemented in CViewContainer, CTextEdit, COpenGLView, and CLayeredViewContainer.

void registerViewEventListener | ( | IViewEventListener * | listener | ) |

void registerViewListener | ( | IViewListener * | listener | ) |

void registerViewMouseListener | ( | IViewMouseListener * | listener | ) |

void removeAllAnimations | ( |  | ) |

void removeAnimation | ( | IdStringPtr | name | ) |

bool removeAttribute | ( | const CViewAttributeID | id | ) |

remove an attribute

bool removed | ( | CView * | parent | ) |
| virtual

view is removed from parent view

Parameters

  parent | parent view

Returns
  true if view successfully removed from parent

Reimplemented in CTextButton, CViewContainer, CParamDisplay, CDataBrowser, CSplitView, UIViewSwitchContainer, COpenGLView, CShadowViewContainer, and CLayeredViewContainer.

void setAlphaValue | ( | float | alpha | ) |
| virtual

set alpha value which will be applied when drawing this view

Reimplemented in CLayeredViewContainer.

void setAlphaValueNoInvalidate | ( | float | value | ) |
| protected

bool setAttribute | ( | const CViewAttributeID | aId,
|  | const uint32_t | inSize,
|  | const void * | inData
| ) |  |

set an attribute

copies data into the attribute.

If it does not exist, creates a new attribute.

Parameters

  aId | the ID of the Attribute
  inSize | the size of the outData pointer
  inData | a pointer to the data

Returns
  true if attribute was set

bool setAttribute | ( | const CViewAttributeID | id,
|  | const T & | data
| ) |  |
| inline

set an attribute

void setAutosizeFlags | ( | int32_t | flags | ) |
| virtual

set autosize flags

Reimplemented in CDataBrowser, CScrollView, and CTabView.

void setBackground | ( | CBitmap * | background | ) |
| virtual

set the background image of this view

Parameters

  background | new background bitmap

Reimplemented in CAnimKnob, and CCheckBox.

void setDirty | ( | bool | val = `true` | ) |
| virtual

set the view to dirty so that it is redrawn in the next idle.

Thread Safe !

Reimplemented in CControl, and CVuMeter.

void setDisabledBackground | ( | CBitmap * | background | ) |
| virtual

set background image used when the mouse is not enabled

Parameters

  background | new disabled background bitmap

void setDropTarget | ( | const SharedPointer< IDropTarget > & | dt | ) |

set a custom drop target

void setHitTestPath | ( | CGraphicsPath * | path | ) |

Parameters

  path | the path to use for hit testing. The path will be translated by this views origin, so that the path must not be set again, if the view is moved. Otherwise when the size of the view changes, the path must also be set again.

void setMouseableArea | ( | const CRect & | rect | ) |
| virtual

set the area in which the view reacts to the mouse

void setMouseEnabled | ( | bool | bEnable = `true` | ) |
| virtual

turn on/off mouse usage for this view

void setParentFrame | ( | CFrame * | frame | ) |
| protected

void setParentView | ( | CView * | parent | ) |
| protected

void setSubviewState | ( | bool | state | ) |

void setTooltipText | ( | UTF8StringPtr | text | ) |

void setTransparency | ( | bool | val | ) |
| virtual

set views transparent state

Reimplemented in CScrollView.

void setViewFlag | ( | int32_t | bit,
|  | bool | state
| ) |  |
| protected

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid = `true`
| ) |  |
| virtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented in CTextButton, CFrame, CViewContainer, CSegmentButton, CMultiLineTextLabel, CDataBrowser, CScrollView, CTextEdit, CSplitView, CTabView, CSliderBase, CScrollbar, CListControl, CTextLabel, CVuMeter, CGradientView, CShadowViewContainer, COpenGLView, CLayeredViewContainer, CKnobBase, and CAutoLayoutContainerView.

void setVisible | ( | bool | state | ) |
| virtual

set visibility state

Reimplemented in COpenGLView.

void setWantsFocus | ( | bool | state | ) |
| virtual

set focus support on/off

Reimplemented in CDataBrowser.

void setWantsIdle | ( | bool | state | ) |

enable/disable onIdle() callback

virtual bool sizeToFit | ( |  | ) |
| inlinevirtual

resize view to optimal size

Reimplemented in CTextButton, CAnimKnob, CViewContainer, CSlider, CKickButton, CRockerSwitch, CMultiLineTextLabel, CCheckBox, CAnimationSplashScreen, CRowColumnView, CSplitView, CVuMeter, CTextLabel, COnOffButton, CKnobBase, CSwitchBase, CMovieButton, and CMovieBitmap.

void takeFocus | ( |  | ) |
| virtual

called if view should take focus

Reimplemented in COptionMenu, CViewContainer, and CTextEdit.

T& translateToGlobal | ( | T & | t,
|  | bool | ignoreFrame = `false`
| ) |  | const
| inline

translates a local coordinate to a global one using parent transforms

T translateToGlobal | ( | const T & | t,
|  | bool | ignoreFrame = `false`
| ) |  | const
| inline

translates a local coordinate to a global one using parent transforms

T& translateToLocal | ( | T & | t,
|  | bool | ignoreFrame = `false`
| ) |  | const
| inline

translates a global coordinate to a local one using parent transforms

T translateToLocal | ( | const T & | t,
|  | bool | ignoreFrame = `false`
| ) |  | const
| inline

translates a local coordinate to a global one using parent transforms

void unregisterViewEventListener | ( | IViewEventListener * | listener | ) |

void unregisterViewListener | ( | IViewListener * | listener | ) |

void unregisterViewMouseListener | ( | IViewMouseListener * | listener | ) |

virtual bool wantsFocus | ( |  | ) | const
| inlinevirtual

check if view supports focus

Reimplemented in CDataBrowser, and CTextEdit.

bool wantsIdle | ( |  | ) | const
| inline

returns if the view wants idle callback or not

virtual bool wantsWindowActiveStateChangeNotification | ( |  | ) | const
| inlinevirtual

whether this view wants to be informed if the window's active state changes

## Member Data Documentation

uint32_t idleRate = 30
| inlinestatic

global idle rate in Hz, defaults to 30 Hz

bool kDirtyCallAlwaysOnMainThread = false
| static

if this is true, setting a view dirty will call invalid() instead of checking it in idle.

Default value is false.

The documentation for this class was generated from the following files:

- cview.h
- cview.cpp